<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierVehicleResult_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierVehicleResult_V2 extends AbstractStructArrayBase
{
    /**
     * The IdentifierVehicleResult_V2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierVehicleResult_V2[]
     */
    public $IdentifierVehicleResult_V2;
    /**
     * Constructor method for ArrayOfIdentifierVehicleResult_V2
     * @uses ArrayOfIdentifierVehicleResult_V2::setIdentifierVehicleResult_V2()
     * @param \StructType\IdentifierVehicleResult_V2[] $identifierVehicleResult_V2
     */
    public function __construct(array $identifierVehicleResult_V2 = array())
    {
        $this
            ->setIdentifierVehicleResult_V2($identifierVehicleResult_V2);
    }
    /**
     * Get IdentifierVehicleResult_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierVehicleResult_V2[]|null
     */
    public function getIdentifierVehicleResult_V2()
    {
        return isset($this->IdentifierVehicleResult_V2) ? $this->IdentifierVehicleResult_V2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIdentifierVehicleResult_V2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIdentifierVehicleResult_V2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIdentifierVehicleResult_V2ForArrayConstraintsFromSetIdentifierVehicleResult_V2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIdentifierVehicleResult_V2IdentifierVehicleResult_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierVehicleResult_V2IdentifierVehicleResult_V2Item instanceof \StructType\IdentifierVehicleResult_V2) {
                $invalidValues[] = is_object($arrayOfIdentifierVehicleResult_V2IdentifierVehicleResult_V2Item) ? get_class($arrayOfIdentifierVehicleResult_V2IdentifierVehicleResult_V2Item) : sprintf('%s(%s)', gettype($arrayOfIdentifierVehicleResult_V2IdentifierVehicleResult_V2Item), var_export($arrayOfIdentifierVehicleResult_V2IdentifierVehicleResult_V2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IdentifierVehicleResult_V2 property can only contain items of type \StructType\IdentifierVehicleResult_V2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IdentifierVehicleResult_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleResult_V2[] $identifierVehicleResult_V2
     * @return \ArrayType\ArrayOfIdentifierVehicleResult_V2
     */
    public function setIdentifierVehicleResult_V2(array $identifierVehicleResult_V2 = array())
    {
        // validation for constraint: array
        if ('' !== ($identifierVehicleResult_V2ArrayErrorMessage = self::validateIdentifierVehicleResult_V2ForArrayConstraintsFromSetIdentifierVehicleResult_V2($identifierVehicleResult_V2))) {
            throw new \InvalidArgumentException($identifierVehicleResult_V2ArrayErrorMessage, __LINE__);
        }
        if (is_null($identifierVehicleResult_V2) || (is_array($identifierVehicleResult_V2) && empty($identifierVehicleResult_V2))) {
            unset($this->IdentifierVehicleResult_V2);
        } else {
            $this->IdentifierVehicleResult_V2 = $identifierVehicleResult_V2;
        }
        return $this;
    }
    /**
     * Add item to IdentifierVehicleResult_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleResult_V2 $item
     * @return \ArrayType\ArrayOfIdentifierVehicleResult_V2
     */
    public function addToIdentifierVehicleResult_V2(\StructType\IdentifierVehicleResult_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierVehicleResult_V2) {
            throw new \InvalidArgumentException(sprintf('The IdentifierVehicleResult_V2 property can only contain items of type \StructType\IdentifierVehicleResult_V2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IdentifierVehicleResult_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierVehicleResult_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierVehicleResult_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierVehicleResult_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierVehicleResult_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierVehicleResult_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierVehicleResult_V2
     */
    public function getAttributeName()
    {
        return 'IdentifierVehicleResult_V2';
    }
}
